/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

window.onload = function() {
	
	canvas = document.getElementById("canvas");
	contexto = canvas.getContext("2d");
	
	depurar=0;
	boton_depurar = document.getElementById("boton_depurar"); //boton de depurar

	//Anadimos los listener para los eventos
	canvas.addEventListener('mouseup', raton_liberado, false);
	canvas.addEventListener('mousemove', raton_movido, false);
	canvas.addEventListener('mousedown', mouse_down, false);
	
	//Inicializamos los instrumentos
	instrumentos=new Instrumentos();
	
	//Inicializamos el chooser
	chooser=new Slide_chooser(100,50,ANCHURA_VENTANA-200,ALTURA_VENTANA-100,75,0);
	chooser.alpha=0.5;
	
	//Inicializamos los botones
	boton_comprar=new Boton("boton_tiendainstrumentos",chooser.x+chooser.w/2-40,chooser.y+chooser.h-60,50,50);
	boton_volver=new Boton("boton_volver",chooser.x+chooser.w-55,chooser.y+20,30,30);
	
	//Inicializamos la imagen de fondo
	fondo=new Image();
	fondo.src=URL_IMAGENES+"scenarios/tienda_instrumentos_blur.jpg";
	
	//Inicializamos el escenario
	grid=new Grid();
	
	down=0;
	
	//Progreso de la carga
	var total=3+instrumentos.instrumentos.length;
	trozo=100/total;
	progreso=1;
	
	var i;
	for(i=0;i<instrumentos.instrumentos.length;i++){
		instrumentos.instrumentos[i].imagen.onload=function(){progreso+=trozo;}
	}
	
	fondo.onload=function(){
		progreso+=trozo;
		tam_image_square_x=fondo.width/GRID_COLUMNS;
		tam_image_square_y=fondo.height/GRID_ROWS;
	}
	
	boton_comprar.image.onload=function(){progreso+=trozo;}
	boton_comprar.over_image.onload=function(){progreso+=trozo;}
	boton_volver.image.onload=function(){progreso+=trozo;}
	boton_volver.over_image.onload=function(){progreso+=trozo;}
	
	//Inicializamos el slide
	down_x=0;
	
	//Para lanzar el fadein
	fadein_alpha=1.0;
	//Para lanzar el fadeout
	fadeout_alpha=1.0;
	
	//Lanzamos el evento draw_progressbar
	interval=setInterval("run()",INTERVALO_REFRESCAR_PANTALLA);
	
	//Bloqueamos el control inicialmente
	bloquear();	
}

function run(){
	animar();
	dibujar();
}

function animar(){	
}

function dibujar() {

	if(progreso<100){
		draw_progressbar(progreso);
	}else{
	
		dibujar_fondo();
		dibujar_chooser();
		
		dibujar_botones();
		
		//Depuramos si hemos activado el modo depurar
		if(depurar){
			dibujar_depurar();
		}
		
		draw_fadein();
		draw_fadeout();
	}
}

function actualiza_slide(x_evento,y_evento){	
		
	var i=chooser.opcion_seleccionada;
	var desplazamiento=x_evento-down_x;
	
	//Instrumento izquierda
	var rel=instrumentos.instrumentos[i].imagen_w/instrumentos.instrumentos[i].imagen_h;
	chooser.lienzo_w[0]=chooser.lienzo_h*rel;
	
	//Instrumento derecha
	var rel=instrumentos.instrumentos[i+1].imagen_w/instrumentos.instrumentos[i+1].imagen_h;
	chooser.lienzo_w[1]=chooser.lienzo_h*rel;	
	
	//Instrumento izquierda
	chooser.trozo_izquierda=0;
	chooser.coordenadas[0]=chooser.down_x[0]+desplazamiento;
	chooser.image_w[0]=instrumentos.instrumentos[i].imagen_w;
	if(chooser.coordenadas[0]<chooser.x+chooser.margen){
		chooser.trozo_izquierda=chooser.x+chooser.margen-chooser.coordenadas[0];
		chooser.image_x[0]=(chooser.trozo_izquierda/chooser.lienzo_w[0])*instrumentos.instrumentos[i].imagen_w;
		chooser.lienzo_x[0]=chooser.x+chooser.margen;
		chooser.image_w[0]-=chooser.image_x[0];
		chooser.lienzo_w[0]-=chooser.trozo_izquierda;
	}else{
		chooser.image_x[0]=0;
		chooser.lienzo_x[0]=chooser.coordenadas[0];
		chooser.image_w[0]=instrumentos.instrumentos[i].imagen_w;
	}
	
	//Instrumento derecha
	chooser.coordenadas[1]=chooser.down_x[1]+desplazamiento;
	chooser.image_w[1]=instrumentos.instrumentos[i+1].imagen_w;
	if(chooser.coordenadas[1]+chooser.lienzo_w[1]>chooser.x+chooser.w-chooser.margen){
		chooser.trozo_derecha=chooser.coordenadas[1]+chooser.lienzo_w[1]-(chooser.x+chooser.w-chooser.margen);
		chooser.image_w[1]-=(chooser.trozo_derecha/chooser.lienzo_w[1])*instrumentos.instrumentos[i+1].imagen_w;
		chooser.lienzo_w[1]-=chooser.trozo_derecha;
	}
	
	//Comprobamos si hemos pasado de elemento
	if(i<instrumentos.instrumentos.length-2 && chooser.coordenadas[1]>chooser.x+chooser.w/3 && chooser.coordenadas[1]<chooser.x+chooser.w/2){
		chooser.pasar_elemento_alante();
	}else if(i>0 && chooser.coordenadas[0]>chooser.x+2*(chooser.w/3) && chooser.coordenadas[0]<chooser.x+chooser.w){
		chooser.pasar_elemento_atras();
	}
}


function activar_depurar(){
	depurar=!depurar;
	if(depurar){
		document.formulario.texto_banda.style.display="block";
		document.formulario.texto_user.style.display="block";
	
		imprime_mensaje("Modo depurar activado");
	}else{
		document.formulario.texto_banda.style.display="none";
		document.formulario.texto_user.style.display="none";
	
		imprime_mensaje("Modo depurar desactivado");
	}
}

function imprime_mensaje(mensaje){
	document.formulario.texto_mensaje.value=mensaje;
}

function bloquear(){blok=1;}
function desbloquear(){blok=0;}