/***

Copyright 2011-2012 Carlos Moreno Munoz

This file is part of Vands.

Vands is free software: you can redistribute it and/or modify
it under the terms of the GNU Affero General Public License as published by
the Free Software Foundation, either version 3 of the License, or
(at your option) any later version.

Foobar is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU Affero General Public License for more details.

You should have received a copy of the GNU Affero General Public License
along with Foobar.  If not, see <http://www.gnu.org/licenses/>.
****/

window.onload = function() {
	
	canvas = document.getElementById("canvas");
	contexto = canvas.getContext("2d");
	
	depurar=0;
	boton_depurar = document.getElementById("boton_depurar"); //boton de depurar

	//Anadimos los listener para los eventos
	canvas.addEventListener('mouseup', raton_liberado, false);
	canvas.addEventListener('mousemove', raton_movido, false);
	canvas.addEventListener('mousedown', mouse_down, false);
	
	//Inicializamos el escenario
	escenario=new Escenario();
	grid=new Grid();
	//Inicializamos la banda
	banda=new Banda();
	//Inicializamos el publico
	publico=new Publico();
	
	//Progreso de la carga
	var total=2+banda.miembros.length+banda.instrumentos.length+publico.publico.length;
	trozo=100/total;
	progreso=1;
	
	escenario.fondo.onload=function(){
		progreso+=trozo;
		tam_image_square_x=escenario.fondo.width/GRID_COLUMNS;
		tam_image_square_y=escenario.fondo.height/GRID_ROWS;
	}
	
	banda.miembros[0].cuerpo_img[0].onload=function(){progreso+=trozo;};
	
	var i;
	for(i=0;i<banda.miembros.length;i++)
		banda.miembros[i].cara_img.onload=function(){progreso+=trozo;};

	for(i=0;i<banda.instrumentos.length;i++)
		banda.instrumentos[i].objeto_img.onload=function(){
			progreso+=trozo;
		};

	for(i=0;i<publico.publico.length;i++)
		publico.publico[i].cara_img.onload=function(){progreso+=trozo;};
	
	//Para lanzar el fadein
	fadein_alpha=1.0;
	//Para lanzar el fadeout
	fadeout_alpha=1.0;
	
	//Lanzamos el evento draw_progressbar
	interval=setInterval("run()",INTERVALO_REFRESCAR_PANTALLA);
	
	//Bloqueamos el control incialmente
	bloquear();	
}

function run(){
	animar();
	dibujar();
}

function animar(){
}

function dibujar() {

	if(progreso<100){
		draw_progressbar(progreso);
	}else{

		dibujar_fondo();
		dibujar_banda();
		dibujar_publico();
		
		//Depuramos si hemos activado el modo depurar
		if(depurar){
			dibujar_depurar();
		}
		
		draw_fadein();
		draw_fadeout();
	}
}

function activar_depurar(){
	depurar=!depurar;
	if(depurar){
		document.formulario.texto_banda.style.display="block";
		document.formulario.texto_user.style.display="block";
	
		imprime_mensaje("Modo depurar activado");
	}else{
		document.formulario.texto_banda.style.display="none";
		document.formulario.texto_user.style.display="none";
	
		imprime_mensaje("Modo depurar desactivado");
	}
}

function imprime_mensaje(mensaje){
	document.formulario.texto_mensaje.value=mensaje;
}

function bloquear(){blok=1;}
function desbloquear(){blok=0;}